import java.util.ArrayList;

public class Naloga5 {
    static String[][] getEditDistanceAlignments(String s1, String s2) {
        int m = s1.length();
        int n = s2.length();
        int[][] dp = new int[m + 1][n + 1];


        for (int i = 0; i <= m; i++) dp[i][0] = i;
        for (int j = 0; j <= n; j++) dp[0][j] = j;


        for (int i = 1; i <= m; i++) {
            for (int j = 1; j <= n; j++) {
                if (s1.charAt(i - 1) == s2.charAt(j - 1)) {
                    dp[i][j] = dp[i - 1][j - 1];
                } else {
                    dp[i][j] = 1 + Math.min(dp[i - 1][j - 1], Math.min(dp[i - 1][j], dp[i][j - 1]));
                }
            }
        }

        ArrayList<String[]> result = new ArrayList<>();
        backtrack(s1, s2, m, n, "", "", dp, result);

        String[][] alignments = new String[result.size()][2];
        for (int i = 0; i < result.size(); i++) {
            alignments[i][0] = result.get(i)[0];
            alignments[i][1] = result.get(i)[1];
        }
        return alignments;
    }

    static void backtrack(String s1, String s2, int i, int j, String aligned1, String aligned2, int[][] dp, ArrayList<String[]> result) {
        if (i == 0 && j == 0) {
            result.add(new String[]{new StringBuilder(aligned1).reverse().toString(), new StringBuilder(aligned2).reverse().toString()});
            return;
        }

        if (i > 0 && j > 0 && s1.charAt(i - 1) == s2.charAt(j - 1) && dp[i][j] == dp[i - 1][j - 1]) {
            backtrack(s1, s2, i - 1, j - 1, aligned1 + s1.charAt(i - 1), aligned2 + s2.charAt(j - 1), dp, result);
        }

        if (i > 0 && j > 0 && dp[i][j] == dp[i - 1][j - 1] + 1) {
            backtrack(s1, s2, i - 1, j - 1, aligned1 + s1.charAt(i - 1), aligned2 + s2.charAt(j - 1), dp, result);
        }

        if (i > 0 && dp[i][j] == dp[i - 1][j] + 1) {
            backtrack(s1, s2, i - 1, j, aligned1 + s1.charAt(i - 1), aligned2 + '-', dp, result);
        }

        if (j > 0 && dp[i][j] == dp[i][j - 1] + 1) {
            backtrack(s1, s2, i, j - 1, aligned1 + '-', aligned2 + s2.charAt(j - 1), dp, result);
        }
    }
}

